'' automatically generated by fastspin v3.7.1 on Mon Apr 30 13:24:12 2018
'' command line: /opt/spin2cpp/bin/fastspin -q -O -w toggler.spin 

CON
	__MBOX_SIZE = 5
	__STACK_SIZE = 1
VAR
  long __mbox[__MBOX_SIZE]   ' mailbox for communicating with remote COG
  long __objmem[0]          ' space for hub data in COG code
  long __stack[__STACK_SIZE] ' stack for new COG
  byte __cognum              ' 1 + the ID of the running COG (0 if nothing running)

'' Code to start the object running in its own COG
'' This must always be called before any other methods
PUB __coginit(id)
  if (__cognum == 0) ' if the cog isn't running yet
    __fixup_addresses
    longfill(@__mbox, 0, __MBOX_SIZE)
    __mbox[1] := @pasm__init - @entry
    __mbox[2] := @__objmem
    __mbox[3] := @__stack
    if (id < 0)
      id := cognew(@entry, @__mbox)
    else
      coginit(id, @entry, @__mbox) ' actually start the cog
    __cognum := id + 1
  return id

PUB __cognew
  return __coginit(-1)

'' Code to stop the remote COG
PUB __cogstop
  if __cognum
    __lock  ' wait until everyone else is finished
    cogstop(__cognum~ - 1)
    __mbox[0] := 0
    __cognum := 0

'' Code to lock access to the PASM COG
'' The idea here is that (in theory) multiple Spin bytecode threads might
'' want access to the PASM COG, so this lock mackes sure they don't step on each other.
'' This method also makes sure the remote COG is idle and ready to receive commands.
PRI __lock
  repeat
    repeat until __mbox[0] == 0   ' wait until no other Spin code is using remote
    __mbox[0] := __cognum         ' try to claim it
  until __mbox[0] == __cognum     ' make sure we really did get it

  repeat until __mbox[1] == 0     ' now wait for the COG itself to be idle

'' Code to release access to the PASM COG
PRI __unlock
  __mbox[0] := 0

'' Check to see if the PASM COG is busy (still working on something)
PUB __busy
  return __mbox[1] <> 0

'' Code to send a message to the remote COG asking it to perform a method
'' func is the PASM entrypoint of the method to perform
'' if getresult is nonzero then we wait for the remote COG to answer us with a result
'' if getresult is 0 then we continue without waiting (the remote COG runs in parallel
'' We must always call __lock before this, and set up the parameters starting in __mbox[2]
PRI __invoke(func, getresult) : r
  __mbox[1] := func - @entry     ' set the function to perform (NB: this is a HUB address)
  if getresult                   ' if we should wait for an answer
    repeat until __mbox[1] == 0  ' wait for remote COG to be idle
    r := __mbox[2]               ' pick up remote COG result
  __unlock                       ' release to other COGs
  return r

'' Code to convert Spin relative addresses to absolute addresses
'' The PASM code contains some absolute pointers internally; but the
'' regular Spin compiler cannot emit these (bstc and fastspin can, with the
'' @@@ operator, but we don't want to rely on having those compilers).
'' So the compiler inserts a chain of fixups, with each entry having the Spin
'' relative address in the low word, and a pointer to the next fixup in the high word.
'' This code follows that chain and adjusts the relative addresses to absolute ones.
PRI __fixup_addresses | ptr, nextptr, temp
  ptr := __fixup_ptr[0]
  repeat while (ptr)      ' the fixup chain is terminated with a 0 pointer
    ptr := @@ptr          ' point to next fixup
    temp := long[ptr]     ' get the data
    nextptr := temp >> 16 ' high 16 bits contains link to next fixup
    temp := temp & $ffff  ' low 16 bits contains real pointer
    long[ptr] := @@temp   ' replace fixup data with real pointer
    ptr := nextptr
  __fixup_ptr[0] := 0 ' mark fixups as done

'--------------------------------------------------
' Stub functions to perform remote calls to the COG
'--------------------------------------------------

PUB Run(Pin)
  __lock
  __mbox[2] := Pin
  return __invoke(@pasm_Run, 0)

'--------------------------------------------------
' The converted object (Spin translated to PASM)
' This is the code that will run in the remote COG
'--------------------------------------------------

DAT
	org	0
entry
	mov	mboxptr, par
	add	mboxptr, #4
waitloop
	rdlong	mboxcmd, mboxptr wz
 if_e	jmp	#waitloop
	add	mboxptr, #4
	rdlong	arg1, mboxptr
	add	mboxptr, #4
	rdlong	arg2, mboxptr
	sub	mboxptr, #4
	shr	mboxcmd, #2
	jmpret	linkreg, mboxcmd
	wrlong	result1, mboxptr
	sub	mboxptr, #4
	mov	arg1, #0
	wrlong	arg1, mboxptr
	jmp	#waitloop
pasm__init
	mov	objptr, arg1
	mov	sp, arg2
	jmp	linkreg

' 
' PUB run(pin)
pasm_Run
	movs	_Run_ret, linkreg
_Run
	mov	_Run_Pin, arg1
'   DIRA[pin]:=1
	mov	_Run__cse__0001, #1
	shl	_Run__cse__0001, _Run_Pin
	or	DIRA, _Run__cse__0001
' 
'   waitcnt($FFFF|cnt)
	mov	arg1, imm_65535_
	or	arg1, CNT
	waitcnt	arg1, #0
' 
'   repeat
'     OUTA[pin]^=1
	mov	_Run__cse__0002, #1
	shl	_Run__cse__0002, _Run_Pin
L__0003
	xor	OUTA, _Run__cse__0002
	jmp	#L__0003
_Run_ret
	ret

imm_65535_
	long	65535
linkreg
	long	0
mboxcmd
	long	0
mboxptr
	long	0
objptr
	long	0
result1
	long	0
sp
	long	0
COG_BSS_START
	fit	496
	org	COG_BSS_START
_Run_Pin
	res	1
_Run__cse__0001
	res	1
_Run__cse__0002
	res	1
arg1
	res	1
arg2
	res	1
arg3
	res	1
arg4
	res	1
	fit	496
__fixup_ptr
	long	0
